import java.util.*;

/**
 * Abstract class for processors of query that consist 
 * a one line string.
 * 
 * @author Johannes A. Stork
 *
 */
public abstract class LineQueryProcessor {
	
	/**
	 * 
	 * @param line
	 * @return The answer to line
	 */
	public abstract String process(String line);
	
	protected Vector<String> parseHTTPGET(String line) {
		Vector<String> arguments = new Vector<String>();
		
		try {
			System.out.println("Query was: " + line);
		
			/// Cut the arguments par
			/// ...?...=...+...+... ...
			int pos = line.indexOf("=") + 1;
			line = line.substring(pos);
		
			pos = line.indexOf(" ");
			line = line.substring(0, pos);
		 
			/// Collect all arguments
			StringTokenizer st = new StringTokenizer(line, "+");
			
			while(st.hasMoreTokens()) {
				arguments.add(st.nextToken());
			}
			
		} catch (Exception e) {
			e.printStackTrace();
			System.err.println("Was the query misspelled?");
		}
		
		return arguments;
	}
}
