import indexing.*;
import java.util.*;

import sun.misc.GC.LatencyRequest;
/**
 * Class to plug in the index from exercise 1 into the webserver.
 * @author schliefer
 *
 */
public class SearchLQP extends LineQueryProcessor {
	protected indexing.SortedIndex sortedIndex;
	
	public SearchLQP() {
		/// Prapare empty index 
		this.sortedIndex = new SortedIndex();
		
		/// Prepare new Indexer instance
		Indexer indexer = new Indexer("data/index.txt");
			
		/// Let the indexer create a new index from parsing the content files
		indexer.fillIndex(sortedIndex);	
		
		//this.sortedIndex.loadIndex("/home/schliefer/studium/semester_7/such/ueb/blatt1/data/index.txt.dat");
	}
	
	@Override
	public String process(String line) {
		String answer = "";

		try {
			Vector<String> arguments = this.parseHTTPGET(line);
			
			/// Prepare empty result set
			HashSet<String> allHits = new HashSet<String>();
			
			int wordCount = 0;
			String lastQuery = "";
			
			for(String s : arguments) {
				/// Get hits for word s
				Vector<String> result = this.sortedIndex.oneWordQuerie(s.toLowerCase());

				/// Convert list to set
				HashSet<String> hits = new HashSet<String>();
				hits.addAll(result);
			
				if(wordCount == 0) {
					/// First set case
					allHits.addAll(hits);
				} else {
					/// allHits := allHits intersection hits
					allHits.retainAll(hits);
				}
				
				wordCount++;
				lastQuery+= s + " ";
			}
			
			lastQuery = lastQuery.trim();
			
			/// Write HTML
			answer+= "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\" \"http://www.w3.org/TR/html4/strict.dtd\">\n";
			answer+="<html>\n";
			answer+="<head>\n";
			answer+="<title>\n";
			answer+="Results and Search\n";
			answer+="</title>\n";
			answer+="</head>\n";
			answer+="<body>\n";
			answer+= "<h1>Type below</h1>\n";
			answer+="<form action=\"http://localhost:8080/search\" action=\"GET\">\n";
			answer+="<p><br><input name=\"query\" type=\"text\" value=\"" + lastQuery + "\"></p>\n";
			answer+="</form>\n";
			answer+="<hr>\n";
			answer+= "<h1>Results " + allHits.size() + " hits</h1>\n";
			
			for(String word : allHits) {
				answer = answer + word + "<br>\n";
			}
			
			answer+= "</body>";
			answer+= "</html>";
			
		} catch (Exception e) {
			e.printStackTrace();
			System.err.println("Was the query misspelled?");
		}
		return answer;
	}

}
