package indexing;

import java.util.*;
/**
 * 
 * @author Johannes A. Stork
 *
 */
public class IndexElement implements Comparable{
	/// The token or key of this index entry
	String content;
	/// List of all files that contain this token
	Vector<String> fileNames = new Vector<String>();
	/// Number of overall occurences
	int occurences;
	
	/**
	 * Constructor
	 * @param content The key token
	 * @param fileName The first file that contains the key token
	 */
	IndexElement(String content, String fileName) {
		this.content = content;
		this.fileNames.add(fileName);
		this.occurences = 1;
	}
	
	public int compareTo(Object other) {
		
		IndexElement otherIndexElement = (IndexElement) other;
		return this.content.compareTo(otherIndexElement.content);
	}
	
	public String toString() {
		String ret = this.content + " " + this.occurences + " >>> ";
		
		for(String s : this.fileNames) {
			ret = ret + " " + s;
		}
		
		return ret;
	}
}
